/* 
 * 16F88_Ref3_Special
 * PIC16F88]{[h@SĂ̋@\vO
 * 
 * File:   main.c
 * Author: Taichi
 *
 * Created on 2017/02/22, 13:28
 */

// CONFIG1
#pragma config FOSC = INTOSCIO  // Oscillator Selection bits (INTRC oscillator; port I/O function on both RA6/OSC2/CLKO pin and RA7/OSC1/CLKI pin)
#pragma config WDTE = OFF       // Watchdog Timer Enable bit (WDT disabled)
#pragma config PWRTE = OFF      // Power-up Timer Enable bit (PWRT disabled)
#pragma config MCLRE = ON       // RA5/MCLR/VPP Pin Function Select bit (RA5/MCLR/VPP pin function is MCLR)
#pragma config BOREN = ON       // Brown-out Reset Enable bit (BOR enabled)
#pragma config LVP = OFF        // Low-Voltage Programming Enable bit (RB3 is digital I/O, HV on MCLR must be used for programming)
#pragma config CPD = OFF        // Data EE Memory Code Protection bit (Code protection off)
#pragma config WRT = OFF        // Flash Program Memory Write Enable bits (Write protection off)
#pragma config CCPMX = RB3      // CCP1 Pin Selection bit (CCP1 function on RB3)
#pragma config CP = OFF         // Flash Program Memory Code Protection bit (Code protection off)

// CONFIG2
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enable bit (Fail-Safe Clock Monitor disabled)
#pragma config IESO = OFF       // Internal External Switchover bit (Internal External Switchover mode disabled)

// NbNg̐ݒ
#define _XTAL_FREQ 8000000      // 8MHz

// s蓖Ă̒`
#define LED1 RA0 // True ON LED
#define LED2 RA6 // False ON LED
#define SWITCH1 RA1 // Pull Down Switch
#define SWITCH2 RA7 // Pull Up Switch
#define VOLUME RA4 // VR1
#define SENSOR RB4 // Photo Sensor
#define M_IN1 RA2 // H-bridge IN1
#define M_IN2 RA3 // H-bridge IN2
#define TR RB3 // Transistor

// CCP̐ݒ
#define PR2_DATA 0xFF           // PR2 ݒf[^@PR2͎ݒ 8bit̍őlݒ
#define T2_DIV_BY_1 0b00000000  // T2CON ݒf[^@2bitŃ^C}2vXP[^w 00:vXP[1
#define CCP_PWM 0b00001100      // CCP1CON ݒf[^  0000:00+duty2bit,1100:PWM[h

// TIMER0̐ݒ
#define RTCC_INTERNAL 0x00      // pX͓NbNg
#define RTCC_DIV_256 0x00       // vXP[̐ݒl: 1/2 (0b000)
#define TMR0_DATA 0x00          // TMR0̏l
#define CNT_DATA 16             // JE^pϐ̏livZ͉Lj
// (1/NbN) * 4 * vXP[ݒl * (255 - (TMR0l - 1))*JE^pϐ̏l : 1ɂ鎞
// (1/8000000*4*2*(255-(0-1)))*16= 0.004096sec :1ɂ鎞

// CũCN[h
#include <xc.h>
#include <stdio.h>
#include <stdlib.h>
#include "uart.h"

// O[oϐ
unsigned int cnt; // 荞݊֐ŎgpJEgϐ
unsigned int tmr_duty; // Timer0荞ݗpPWMduty
unsigned int dmy_duty;
unsigned int r_flag; // ]ort]tO

// vg^Cv錾
void command_read(char *c, int *i);
void setADCChannel(unsigned char channel);
unsigned int readADCValue(void);
void initPWM1(unsigned char pr2, unsigned char t2ckps);
void setPWM1Duty(unsigned int ccp_duty);
void resetPWM1();
void initTMR0(unsigned char mode);
void setTMR0(unsigned char tmr0);
void interrupt isrTMR0();


void main(void) {
    char c;
    int i;
    unsigned int ccp_duty; // CCPW[PWMduty
    
    OSCCON = 0b01110000;    // NbN̎g8MHzɐݒ
    
    PORTA = 0x00;           // PORTA
    PORTB = 0x00;           // PORTB
    TRISA = 0b10010010;     // PORTA̓o͐ݒ RA1,7SWITCH, RA4VOLUME
    TRISB = 0b00010100;     // PORTB̓o͐ݒ RB2RX, RB4SENSOR

    ANSEL = 0b00010000;     // AN4L
    ADCON0 = 0b10000001;    // 110:Fosc/64(擪1ADCON1bit6, 1:ADON
    ADCON1 = 0b11000000;    // El, AVdd, AVss(ddƂ) 
    
    cnt = CNT_DATA;             // TMR0݂𗘗p1bJE^pϐ
    initTMR0(RTCC_INTERNAL | RTCC_DIV_256);
    setTMR0(TMR0_DATA);         // TMR0̏lݒ
    TMR0IE = 0;                   // TMR0݂Ȃ
    GIE = 1;                    // O[o݂
      
    initUART();             // VAʐMݒ
    __delay_ms(100);
    
    while(1){
        command_read(&c,&i);
        
        // LED ON OFFR}h
        if(c=='l'){
            if(i==0){
                LED1=0;
                LED2=0;
                printf("LED1,LED2 LOW\n");
            }
            else if(i==1){
                LED1=1;
                LED2=1;
                printf("LED1,LED2 HIGH\n");
            }
            else{
                printf("Error Invalid Number: %d\n",i);
            }
        }
        
        // TRANSISTOR ON OFFR}h
        else if(c=='r'){
            if(i==0){
                TR=0;
                printf("TRANSISTOR OFF\n");
            }
            else if(i==1){
                TR=1;
                printf("TRANSISTOR ON\n");
            }
            else{
                printf("Error Invalid Number: %d\n",i);
            }
        }
        
        // ZT[ƃXCb`̏ԊmFR}h
        else if(c=='s'){
            while(!RCIF){ // ͂܂ŌJԂ
                if(SWITCH1==1){ // XCb`1̏Ԃ\
                    printf("Switch1: RIGHT, "); 
                }
                else{
                    printf("Switch1: LEFT , ");
                }
                if(SWITCH2==1){ // XCb`2̏Ԃ\
                    printf("Switch2: RIGHT, "); 
                }
                else{
                    printf("Switch2: LEFT , ");
                }
                if(SENSOR==1){ // tHgC^v^̏Ԃ\
                    printf("Sensor: Not Reflect\n");
                }
                else{
                    printf("Sensor: Reflect\n");
                }
                __delay_ms(200);
            }
        }
        
        // ADRo[^[lmFR}h
        else if(c=='a'){
            while(!RCIF){ // ͂܂ŌJԂ
                setADCChannel(4);  // A/DϊΏۃ`lݒ
                 __delay_us(50);   // ANBWVԁi50}CNbj
                printf("ADC Value: %d\n", readADCValue());      // A/Dϊl\
                __delay_ms(200);
            }
        }
        
        // CCPW[PWM
        else if(c=='p'){
            TMR0IE = 0;  // TMR0݂~
            initPWM1(PR2_DATA, T2_DIV_BY_1);    // CCP1PWM[hɐݒ  
            if(i==0){ // ~
                setPWM1Duty(0);    // f[eBݒ
                M_IN1=0;
                M_IN2=0;
                TR=0;
                printf("Motor STOP\n");
            }
            else if(0<i && i<1024){ // ]
                setPWM1Duty(i);    // f[eBݒ
                LED2=1;
                printf("Motor RUN, Duty: %d, Forward rotation,\n",i);
            }
            else if(i==9999){ // [^[ {[샂[h
                while(!RCIF){// ͂܂ŌJԂ
                    setADCChannel(4);        // A/DϊΏۃ`lݒ
                    __delay_us(50);          // ANBWVԁi50}CNbj
                    ccp_duty = readADCValue();   // A/Dϊl擾
                    setPWM1Duty(ccp_duty);    // dutyݒ
                    LED2=1;
                    printf("Motor Volume Mode, Duty: %d\n", ccp_duty);      // duty\
                    __delay_ms(200);                    // 200~b̑҂
                }
            }
            else{
                printf("Error Invalid Number: %d\n",i);
                printf("0 ~ 1023(Normal Mode) or 9999(Motor Volume Mode)\n");
            }
        }
        
        // Timer0pPWM
        else if(c=='t'){
            resetPWM1();       // CCPW[PWM~ 
            TMR0IE = 1;        // TMR0݂
            if(i==0){ // ~
                dmy_duty=0;    // f[eBݒ
                M_IN1=0;
                M_IN2=0;
                TR=0;
                printf("Motor STOP\n");
            }
            else if(0<i && i<1024){ // ]
                dmy_duty=i;    // f[eBݒ
                r_flag=1;
                LED2=1;
                printf("Motor RUN, Duty: %d, Forward rotation,\n",i);
            }
            else if(-1024<i && i<0){ // t]
                dmy_duty=-i;    // f[eBݒ
                r_flag=0;
                LED2=0;
                printf("Motor RUN, Duty: %d, Reverse rotation\n",-i);
            }
            else if(i==9999){ // [^[ {[샂[h
                while(!RCIF){// ͂܂ŌJԂ
                    setADCChannel(4);        // A/DϊΏۃ`lݒ
                    __delay_us(50);          // ANBWVԁi50}CNbj
                    dmy_duty = readADCValue();   // A/Dϊl擾
                    printf("Motor Volume Mode, Duty: %d\n", tmr_duty);      // duty\
                    if(SWITCH2==1 && tmr_duty==0){ // XCb`HIGH[^~ԂȂ琳]ؑ
                        r_flag=0;
                        LED2=0;
                    }
                    if(SWITCH2==0 && tmr_duty==0){ // XCb`LOW[^~ԂȂt]ؑ
                        r_flag=1;
                        LED2=1;
                    }
                    __delay_ms(200);                    // 200~b̑҂
                }
            }
            else{
                printf("Error Invalid Number: %d\n",i);
                printf("-1023 ~ 1023(Normal Mode) or 9999(Motor Volume Mode)\n");
            }
        }
        
        // So͒~R}h
        else if(c=='e' || c=='q'){
            LED1=0;
            LED2=0;
            M_IN1=0;
            M_IN2=0;
            resetPWM1();
            TMR0IE=0;
            TR=0;
            printf("STOP ALL\n");
        }
        
        // wv\
        else if(c=='h'){
            printf("\n[COMMAND LIST]\n");
            printf("l,*    : LED1 & LED2 (*=0:LOW, *=1:HIGH)\n");
            printf("r,*    : TRANSISTOR (*=0;OFF, *=1:ON)\n");
            printf("s      : SWITCH & SENSOR status\n");
            printf("a      : ADC value\n");
            printf("p,**** : CCP PWM (****=0~1023:duty)\n");
            printf("p,9999 : CCP PWM Volume Control Mode\n");
            printf("t,**** : TIMER0 PWM (****=-1023~1023:duty)\n");
            printf("t,9999 : TIMER0 PWM Volume Control Mode\n");
            printf("e      : STOP ALL\n");
            printf("q      : STOP ALL\n");
            printf("c      : COPYRIGHT\n");
            printf("h      : HELP\n\n");
        }
        
        // NWbg\
        else if(c=='c'){
            printf("\n******************************\n");
            printf("16F88_Ref3_Special.X\n");
            printf("Creation Date: 2017/02/22\n");
            printf("Copyright(c) 2017 Taichi ITO\n");
            printf("All Right Reserved\n");
            printf("******************************\n\n");
        }
        
        // o^R}h
        else{
            printf("Error Invalid Command\n");
        }
    }
}


// PCR}hǂݎ֐
void command_read(char *c, int *i){
    char str[16], num[16];
    int j,k=0;
    
    //@sR[h܂ŕǂݎ 
    for(j=0;j<16;j++){
        str[j]=getch();
        if(str[j]=='\n'){
            break;
        }
    }
    str[j]='\0';
    
    // , ̈ʒuǂݎ
    for(j=0;j<16;j++){
        if(str[j]==','){
            k=j+1;
            break;
        }
    }
    
    // , ȍ~̕numɑ
    for(j=0;j<16;j++){
        num[j]=str[k];
        if(str[k]=='\0'){
            break;
        }
        k++;
    }
    
    *c=str[0]; // R}hL
 //   printf("c=%c\r\n",*c);
    *i=atoi(num); // R}hl
 //   printf("i=%d\r\n",*i);
  }


// A/DϊΏۃ`lݒ֐
void setADCChannel(unsigned char channel)
{
    ADCON0 &= 0b11000111;               // CHS<2:0> bit3,4,5
    ADCON0 |= (channel << 3);
}
 
 // A/Dϊl擾֐ A/Dϊli10bit, 0-1023jԂ
unsigned int readADCValue(void)
{
    GO_nDONE = 0b1; // ADϊJn
    while(GO_nDONE); // ADϊAGO_nDONE1
    return ((ADRESH << 8) + ADRESL);
}


// CCPW[ݒ肷֐
void initPWM1(unsigned char pr2, unsigned char t2ckps)
{
    PR2 = pr2; //PR2WX^͎̐ݒ 
    CCP1CON = CCP_PWM; //CCP1CONWX^ݒ
    setPWM1Duty(0); // Duty͏l0ɂĂ
    T2CON = t2ckps; // ^C}2o̓|XgXP[^w肨уvXP[^w
    T2CON |= 0x04; // 0b00000100 ^C}2ON
}
 
// CCPW[dutyݒ肷֐
void setPWM1Duty(unsigned int ccp_duty)
{
    CCPR1L = ccp_duty >> 2; // CCPR1LWX^ɂduty̏8bitZbg
    CCP1CON &= 0b11001111; // CCP1CONWX^ bit}XN
    CCP1CON |= 0b00110000 & (ccp_duty << 4); // CCP1CON̏2bitdutỷ2bitZbg
}

// CCPW[~֐
void resetPWM1()
{
    PR2 = 0; 
    CCP1CON = 0; 
    CCPR1L=0;
    T2CON = 0;
}

// ^C}[0荞ݐݒ֐
void initTMR0(unsigned char mode)
{
    OPTION_REG &= 0b11000000; // rbg}XN
    OPTION_REG |= mode; // pX͓orOAvXP[lݒ
    TMR0 = 0x00; // TMR0̃JEgl0ɂ
}
 
// ^C}[0荞ݏlݒ֐
void setTMR0(unsigned char tmr0)
{
    TMR0 = tmr0; // TMR0̏lݒ
}
 
// ^C}[0荞ݔɎs֐
void interrupt isrTMR0() // ISR:Interrupt Service Routine 
{
    TMR0IF = 0;       // TMR0݂NA
    TMR0 = TMR0_DATA; // TMR0JE^JnlăZbg
    cnt--;
    if((tmr_duty/64)>cnt){ //duty10bit4bitɌ炷 (1024/16=64)
        if(r_flag==1){
            M_IN1=0;
            M_IN2=1;
        }
        else{
            M_IN1=1;
            M_IN2=0;
        }
        TR=1;
    }
    else{
        M_IN1=0;
        M_IN2=0;
        TR=0;
    }
    
    if(cnt == 0){
        cnt = CNT_DATA;         // JE^pϐ
        tmr_duty=dmy_duty;          // dutyXV
    }
}